package be.jeffcheasey88.peeratcode.parser.java;

import be.jeffcheasey88.peeratcode.parser.Token;

public class Value extends JavaElement{

	private Token token;
	
	protected Value(){}
	
	public Value(Token token){
		this.token = token;
		System.out.println(this);
	}
	
	@Override
	public String toString(){
		return "[Value="+token+"]";
	}
	
	public static class ValueContainer extends Value{
		
		private Value value;
		
		public ValueContainer(Value value){
			this.value = value;
			System.out.println(this);
		}
		
		@Override
		public String toString(){
			return "[ContainerValue="+value+"]";
		}
		
	}
	
	public static class BiValue extends Value{
		
		private Value left;
		private Value right;
		
		public BiValue(Value left, Value right){
			this.left = left;
			this.right = right;
			System.out.println(this);
		}
		
		@Override
		public String toString(){
			return "[BiValue left="+left+" right="+right+"]";
		}
	}
	
	public static class TriValue extends Value{
		
		public TriValue(){
			
		}
	}
}
